#!/usr/local/bin/perl
#
# This reads MINFO and extracts all kinds of file information from it.
# The information for the directories apps/, crypto/, ssl/ and test/ will
# be gathered, the rest will be ignored.  A serie of .tmp files will be
# produced from this, to be used in appropriate command procedures.
#

$do_subdirs{"apps"} = 0;
$do_subdirs{"crypto"} = 1;
$do_subdirs{"rsaref"} = 0;
$do_subdirs{"ssl"} = 0;
$do_subdirs{"test"} = 0;

$is_programs{"apps"} = 1;
$is_programs{"crypto"} = 0;
$is_programs{"rsaref"} = 0;
$is_programs{"ssl"} = 1;
$is_programs{"test"} = 1;

$is_libs{"apps"} = 0;
$is_libs{"crypto"} = 1;
$is_libs{"rsaref"} = 1;
$is_libs{"ssl"} = 1;
$is_libs{"test"} = 0;

$PROGRAMS{"apps"} = "";
$PROGRAMS{"crypto"} = "";
$PROGRAMS{"rsaref"} = "";
$PROGRAMS{"ssl"} = "";
$PROGRAMS{"test"} = "";

@subdirs = ("crypto","ssl","rsaref","apps","test");

open(MINFO, "MINFO") || die "MINFO was not found: $@";

$is_in = "";

while(<MINFO>) {
    chop;
    if (m/^RELATIVE_DIRECTORY=(.*)/) {
	$is_in = "";
	$is_subdir = "";
	foreach $s (@subdirs) {
	    if (m/^RELATIVE_DIRECTORY=$s$/) {
		$is in = $1;
	    } else if (m/^RELATIVE_DIRECTORY=$s/ && do_subdirs{$s}) {
		$is_in = $subdir;
		$is_subdir = $1;
		$is_subdir =~ s+$s/++;
	    }
	}
    }
    next if ($is_in eq "");

    if (m/^EXE=(.*)$/) {
	$1 =~ s/ /,/;
	$PROGRAMS{$is_in} = $PROGRAMS{$is_in} . "," . $1;
    }
    if (m/^OBJ=(.*)$/) {
